<?php
namespace BackOfficeOptimizer\Providers;

use Zeedhi\Framework\DataSource\DataSet;

class PermissionProvider{
    protected $connection;

    public function __construct($connection){
        $this->connection = $connection;
    }

    public function getUserPermissions($CDOPERADOR, $NRORG){
        $accessControllStatusSQL = "SELECT CASE WHEN A.NRPERFILACESSO IS NULL THEN 'N' ELSE 'S' END AS CONTROLA_ACESSO, CASE WHEN OP.NRPERFILACESSO IS NULL THEN 'N' ELSE 'S' END AS ADMINISTRADOR FROM AUTPERFILACESSO A LEFT JOIN (SELECT PF.NRPERFILACESSO, OP.NRORG FROM OPERADOR OP INNER JOIN PERFACESSPARC PF ON (PF.NRPARCNEGOCIO = OP.NRPARCNEGOCIO AND PF.NRORG = OP.NRORG) WHERE OP.CDOPERADOR = :CDOPERADOR AND OP.NRORG = :NRORG ) OP ON A.NRPERFILACESSO = OP.NRPERFILACESSO AND A.NRORG = OP.NRORG";
    
        $statement = $this->connection->prepare($accessControllStatusSQL);
        $statement->execute(["CDOPERADOR" => $CDOPERADOR, "NRORG" => $NRORG]);
        $result = $statement->fetchAll();
        $grantAll = count($result) < 1 || $result[0]["ADMINISTRADOR"] === "S" || $result[0]["CONTROLA_ACESSO"] === "N";
        $scopes = [];
        if(!$grantAll){
            $permissionsSQL = "SELECT DISTINCT OT.NROTIMIZADORITEM FROM OPERADOR OP INNER JOIN PERFACESSPARC PF ON (PF.NRPARCNEGOCIO = OP.NRPARCNEGOCIO AND PF.NRORG = OP.NRORG) INNER JOIN OTIMIZADORITEMPER OT ON (OT.NRORG = PF.NRORG AND OT.NRPERFILACESSO = PF.NRPERFILACESSO) WHERE OP.CDOPERADOR = :CDOPERADOR AND OP.NRORG = :NRORG ORDER BY OT.NROTIMIZADORITEM";
        
            $statement = $this->connection->prepare($permissionsSQL);
            $statement->execute(["CDOPERADOR" => $CDOPERADOR, "NRORG" => $NRORG]);
            $scopesRes = $statement->fetchAll();
            if(sizeof($scopesRes) > 0){
                foreach($scopesRes as $sc) {
                    $scopes[] = $sc["NROTIMIZADORITEM"];
                }
            }
        }

        $permissions = [
            "grantAll" => $grantAll,
            "scopes" => $scopes
        ];

        return $permissions;
    }

    public function getPermissionManagementStatus($NRORG){
        $permissionManagementDefinedSQL = "SELECT IDAUTPERFACESSO FROM AUTPERFILACESSO WHERE IDAUTPERFACESSO = 'OTIMIZADORCARD' AND NRORG = :NRORG";
        $statement = $this->connection->prepare($permissionManagementDefinedSQL);
        $statement->execute(["NRORG" => $NRORG]);
        $result = $statement->fetchAll();

        $canAccessPermissionManagement = count($result) > 0;
        return $canAccessPermissionManagement;
    }
}